---
title: ContentIndex.add()
slug: Web/API/ContentIndex/add
tags:
  - Content
  - Content Index API
  - Index
  - Interface
  - Method
  - PWA
  - content index
  - content indexing
---
<div>{{draft}}{{DefaultAPISidebar("Content Index API")}}</div>

<p class="summary">The <strong><code>add()</code></strong> method of the {{domxref("ContentIndex")}} interface registers an item with the {{domxref('Content Index API','content index')}}.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate">ContentIndex.add(<var>ContentDescription</var>).then(...);</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><em>ContentDescription</em></dt>
 <dd>An {{jsxref('Object')}} containing the following data:
 <ul>
  <li><code>id</code>: A unique {{jsxref('String')}} identifier.</li>
  <li><code>title</code>: A {{jsxref('String')}} title for the item. Used in user-visible lists of content.</li>
  <li><code>title</code>: A {{jsxref('String')}} title of the item. Used in user-visible lists of content.</li>
  <li><code>description</code>: A {{jsxref('String')}} description of the item. Used in user-visible lists of content.</li>
  <li><code>url</code>: A {{jsxref('String')}} containing the url of the corresponding HTML document. Needs to be under the scope of the current {{domxref('ServiceWorker','service worker')}}.</li>
  <li><code>category</code>: {{Optional_Inline}} A {{jsxref('String')}} defining the category of content. Can be:
   <ul>
    <li><code>''</code> An empty {{jsxref('String')}}, this is the default.</li>
    <li><code>homepage</code></li>
    <li><code>article</code></li>
    <li><code>video</code></li>
    <li><code>audio</code></li>
   </ul>
  </li>
  <li><code>icons</code>: {{Optional_Inline}} An {{jsxref('Array')}} of image resources, defined as an {{jsxref('Object')}} with the following data:
   <ul>
    <li><code>src:</code> A url {{jsxref('String')}} of the source image.</li>
    <li><code>sizes:</code> {{Optional_Inline}} A {{jsxref('String')}} representation of the image size.</li>
    <li><code>type:</code> {{Optional_Inline}} The {{Glossary("MIME type")}} of the image.</li>
   </ul>
  </li>
 </ul>
 </dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p>Returns a {{jsxref("Promise")}} that resolves with <code>undefined</code></p>

<h3 id="Exceptions">Exceptions</h3>

<dl>
 <dt><code>TypeError</code></dt>
 <dd>If the service worker's registration is not present or the service worker does not contain a {{domxref('FetchEvent')}}.</dd>
 <dd>If the <code>id</code>, <code>title</code>, <code>description</code> or <code>url</code> are missing, not of type {{jsxref('String')}}, or an empty {{jsxref('String')}}.</dd>
 <dd>If <code>icons</code> images are not of image type.</dd>
</dl>

<h2 id="Examples">Examples</h2>

<p>Here we're declaring an item in the correct format and creating an asynchronous function which uses the <code>add</code> method to register it with the {{domxref('Content Index API','content index')}}.</p>

<pre class="brush: js notranslate">// our content
const item = {
  id: 'post-1',
  url: '/posts/amet.html',
  title: 'Amet consectetur adipisicing',
  description: 'Repellat et quia iste possimus ducimus aliquid a aut eaque nostrum.',
  icons: [{
    src: '/media/dark.png',
    sizes: '128x128',
    type: 'image/png',
  }],
  category: 'article'
};

// our asynchronous function to add indexed content
async function registerContent(data) {
  const registration = await navigator.serviceWorker.ready;

  // feature detect Content Index
	if (!registration.index) {
		return;
	}

  // register content
  try {
		await registration.index.add(data);
  } catch (e) {
    console.log('Failed to register content: ', e.message);
  }
}
</pre>

<p>The <code>add</code> method can also be used within the {{domxref('ServiceWorker','service worker')}} scope.</p>

<pre class="brush: js notranslate">// our content
const item = {
  id: 'post-1',
  url: '/posts/amet.html',
  title: 'Amet consectetur adipisicing',
  description: 'Repellat et quia iste possimus ducimus aliquid a aut eaque nostrum.',
  icons: [{
    src: '/media/dark.png',
    sizes: '128x128',
    type: 'image/png',
  }],
  category: 'article'
};

self.registration.index.add(item);
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('Content Index API','#content-index-add','add')}}</td>
   <td>{{Spec2('Content Index API')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.ContentIndex.add")}}</p>

<h2 id="See_also">See also:</h2>

<ul>
 <li><a href="https://web.dev/content-indexing-api/">An introductory article on the Content Index API</a></li>
 <li><a href="https://contentindex.dev/">An app which uses the Content Index API to list and remove 'save for later' content</a></li>
 <li><a href="/en-US/docs/Web/API/Service_Worker_API">Service Worker API, along with information about Cache and CacheStorage</a></li>
</ul>
